/***********************************************************************
	gutenfetch - query and fetch electronic texts from project gutenberg
    Copyright (C) 2001, 2002, 2003 Russell Francis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA

	Last updated on $Date: 2004/07/10 14:06:02 $ by $Author: johntabularasa $.
***********************************************************************/
#ifndef OPT_H
#define OPT_H
#include "stddefs.h"

typedef enum {
	ACTION_NONE,
	ACTION_ERROR,
	ACTION_FETCH_BOOK,
	ACTION_LIST_BOOKS,
	ACTION_MANUAL_SERVER_SELECT,
	ACTION_PRINT_VERSION,
	ACTION_PRINT_USAGE
} action_t;	

#ifdef __cplusplus
extern "C" {
#endif

	int opt_init(void);
	void opt_shutdown(void);
	
	int opt_load_config(void);
	int opt_manual_select_servers(void);
	int opt_write_config(void);
	void opt_generate_new_config_file(void);

	int opt_get_verbose(void);
	void opt_set_verbose(int);

	const char * opt_get_output_file(void);
	void opt_set_output_file(const char *);

	void opt_set_action(action_t);
	action_t opt_get_action(void);

	int opt_set_bookbase(const char *);
	const char *opt_get_bookbase(void);

	void opt_set_filter(const int);
	int opt_get_filter(void);

	void opt_set_cache(const int);
	int opt_get_cache(void);

#if defined(DEBUG)
	void opt_set_debug(const int);
	int opt_get_debug(void);
#endif /* DEBUG */	

#ifdef __cplusplus
}
#endif

#endif /* OPT_H */

